/*
 * NonEmptyIntList.h
 *
 *  Created on: Oct 14, 2008
 *  Revised Oct 2009
 *
 *      Author: bloch
 */

#ifndef NONEMPTYINTLIST_H_
#define NONEMPTYINTLIST_H_

#include "IntList.h"

class NonEmptyIntList: public IntList {
private:
	int first;
	IntList *rest;
public:
	NonEmptyIntList(int firstArg, IntList *restArg);
	int getFirst() const;
	IntList *getRest() const;
	virtual int length() const;
	virtual bool isEmpty() const {
		return false;
	}
	virtual std::ostream& printList(std::ostream &out) const;
	virtual ~NonEmptyIntList();
};

#endif /* NONEMPTYINTLIST_H_ */
